// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ur_msgs:msg/MasterboardDataMsg.idl
// generated code does not contain a copyright notice

#ifndef UR_MSGS__MSG__DETAIL__MASTERBOARD_DATA_MSG__TRAITS_HPP_
#define UR_MSGS__MSG__DETAIL__MASTERBOARD_DATA_MSG__TRAITS_HPP_

#include "ur_msgs/msg/detail/masterboard_data_msg__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const ur_msgs::msg::MasterboardDataMsg & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: digital_input_bits
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "digital_input_bits: ";
    value_to_yaml(msg.digital_input_bits, out);
    out << "\n";
  }

  // member: digital_output_bits
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "digital_output_bits: ";
    value_to_yaml(msg.digital_output_bits, out);
    out << "\n";
  }

  // member: analog_input_range0
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_input_range0: ";
    value_to_yaml(msg.analog_input_range0, out);
    out << "\n";
  }

  // member: analog_input_range1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_input_range1: ";
    value_to_yaml(msg.analog_input_range1, out);
    out << "\n";
  }

  // member: analog_input0
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_input0: ";
    value_to_yaml(msg.analog_input0, out);
    out << "\n";
  }

  // member: analog_input1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_input1: ";
    value_to_yaml(msg.analog_input1, out);
    out << "\n";
  }

  // member: analog_output_domain0
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_output_domain0: ";
    value_to_yaml(msg.analog_output_domain0, out);
    out << "\n";
  }

  // member: analog_output_domain1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_output_domain1: ";
    value_to_yaml(msg.analog_output_domain1, out);
    out << "\n";
  }

  // member: analog_output0
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_output0: ";
    value_to_yaml(msg.analog_output0, out);
    out << "\n";
  }

  // member: analog_output1
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "analog_output1: ";
    value_to_yaml(msg.analog_output1, out);
    out << "\n";
  }

  // member: masterboard_temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "masterboard_temperature: ";
    value_to_yaml(msg.masterboard_temperature, out);
    out << "\n";
  }

  // member: robot_voltage_48v
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_voltage_48v: ";
    value_to_yaml(msg.robot_voltage_48v, out);
    out << "\n";
  }

  // member: robot_current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_current: ";
    value_to_yaml(msg.robot_current, out);
    out << "\n";
  }

  // member: master_io_current
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "master_io_current: ";
    value_to_yaml(msg.master_io_current, out);
    out << "\n";
  }

  // member: master_safety_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "master_safety_state: ";
    value_to_yaml(msg.master_safety_state, out);
    out << "\n";
  }

  // member: master_onoff_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "master_onoff_state: ";
    value_to_yaml(msg.master_onoff_state, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ur_msgs::msg::MasterboardDataMsg & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<ur_msgs::msg::MasterboardDataMsg>()
{
  return "ur_msgs::msg::MasterboardDataMsg";
}

template<>
inline const char * name<ur_msgs::msg::MasterboardDataMsg>()
{
  return "ur_msgs/msg/MasterboardDataMsg";
}

template<>
struct has_fixed_size<ur_msgs::msg::MasterboardDataMsg>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<ur_msgs::msg::MasterboardDataMsg>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<ur_msgs::msg::MasterboardDataMsg>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // UR_MSGS__MSG__DETAIL__MASTERBOARD_DATA_MSG__TRAITS_HPP_
